package edu.rice.rubis.beans;

import java.rmi.RemoteException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.FinderException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.CreateException;
import javax.ejb.RemoveException;
import javax.ejb.EJBException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.io.Serializable;
import java.net.URLEncoder;

public class UserIDHelperBean implements SessionBean
{
  	protected SessionContext sessionContext;
  	protected Context initialContext = null;
  	protected DataSource dataSource = null;
	  
    public Integer getUserID(String username) throws RemoteException
	{
	    	Connection        conn = null;
	    	PreparedStatement stmt = null;
	    	ResultSet rs           = null; 
	    	Integer userId         = null;
	    	try
	    	{
	      		conn = dataSource.getConnection();
                stmt = conn.prepareStatement("SELECT users.id FROM users WHERE nickname=?");
                stmt.setString(1, username);
	      		rs = stmt.executeQuery();
	      		stmt.close();
	      		conn.close();
	    	}
	    	catch (SQLException e)
	    	{
	      		try
	      		{
	        		if (stmt != null) stmt.close();
	        		if (conn != null) conn.close();
	      		}
	      		catch (Exception ignore){}
	      		e.printStackTrace();
	    	}
	    	try 
	    	{
	      		if (rs.first())
	      		{
	        		userId = new Integer(rs.getInt("id"));
	      		}
	    	}
	    	catch (Exception e)
	    	{
	      		e.printStackTrace();
	    	}
            
	    	return userId;
	} 
	
	// ======================== EJB related methods ============================

  	/**
   	* This method is empty for a stateless session bean
   	*/
  	public void ejbCreate() throws CreateException, RemoteException
  	{
  	}

  	/** This method is empty for a stateless session bean */
  	public void ejbActivate() throws RemoteException {}
  	/** This method is empty for a stateless session bean */
  	public void ejbPassivate() throws RemoteException {}
  	/** This method is empty for a stateless session bean */
  	public void ejbRemove() throws RemoteException {}


  	/** 
   	* Sets the associated session context. The container calls this method 
   	* after the instance creation. This method is called with no transaction context. 
   	* We also retrieve the Home interfaces of all RUBiS's beans.
   	*
   	* @param sessionContext - A SessionContext interface for the instance. 
   	* @exception RemoteException - Thrown if the instance could not perform the function 
   	*            requested by the container because of a system-level error. 
   	*/
  	public void setSessionContext(SessionContext sessionContext) throws RemoteException
  	{
    		this.sessionContext = sessionContext;
    		if (dataSource == null)
    		{
      			try
      			{
        			initialContext = new InitialContext(); 
        			dataSource = (DataSource)initialContext.lookup("java:comp/env/jdbc/rubis");
      			}
      			catch (Exception e) 
      			{
        			throw new RemoteException("Cannot get JNDI InitialContext");
      			}
    		}
  	}
}
