package edu.rice.rubis.client;


import java.io.*;
import java.util.*;
import java.net.URL;


public class ClientStats2CSV
{
  public ClientStats2CSV()
  {
  }

  public void go4it(String baseFileName, String outFileName, String[] extensions) 
  {
    try {
      PrintStream out = new PrintStream(new FileOutputStream(outFileName));
        
      for (int j = 0; j < extensions.length; j++) {
          try {          
            FileInputStream fileIn = new FileInputStream ( baseFileName + extensions[j]);
                
            out.println(extensions[j]);
                
            do {
              ObjectInputStream in = new ObjectInputStream(fileIn);
                        
              Stats upRampStats = (Stats) in.readObject();
              Stats runSessionStats = (Stats) in.readObject();
              Stats downRampStats = (Stats) in.readObject();
              Stats allStats = (Stats) in.readObject();
      
              int totalCount = 0;
              int totalErrors = 0;
              long totalTime = 0;
              for (int i = 0; i < runSessionStats.getNbOfStats(); i++) {
                  totalCount += runSessionStats.getCount(i);
                  totalErrors += runSessionStats.getError(i);
                  totalTime += runSessionStats.getTotalTime(i);
              }
                  
              out.println(totalCount + ";" + totalErrors + ";" + totalTime + ";" +
                          runSessionStats.totalSessionTime + ";" +
                          runSessionStats.getNbOfSessions());
              
              out.flush();
            } while(true);
          } catch (IOException e) { e.printStackTrace(); }
      }
    } 
    catch (Exception e) { e.printStackTrace(); }
  }
  

  public static void main(String[] args) 
  {
    ClientStats2CSV clientStats2CSV = new ClientStats2CSV();

    String[] extensions = new String[args.length - 2];
    for (int i = 2; i < args.length; i++) {
        extensions[i - 2] = args[i];
    }
    
    clientStats2CSV.go4it(args[0], args[1], extensions);
  }
}