package edu.rice.rubis.client;


import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;


public class ClientWrapper extends UnicastRemoteObject implements IClientWrapper 
{
	public static String[] clientArgs;
	
	public static RUBiSProperties props;

	ClientRunnerThread p;

	public static void main(String[] args) throws Exception {
	
	
		Registry registry = null;
		
		/*
		try {
			registry = LocateRegistry.getRegistry(MainClient.port);
		}
		catch (ConnectException e) {}
		*/
		
		if (registry == null) {
			registry = LocateRegistry.createRegistry(MainClient.port);
		}
		
		ClientWrapper wrapper = new ClientWrapper(registry);
		
		clientArgs = args;
				
		props = new RUBiSProperties();
		props.checkPropertiesFileAndGetURLGenerator();
	}
	
	
	public ClientWrapper(Registry reg)
		throws RemoteException
	{
		super();
		
		reg.rebind("rubis", this);
	}
	
	
	public void startClient(int id, int numClients, long rampUpMillis, long sessionMillis, long rampDownMillis, 
								 boolean tcpwThinkTime,
								 boolean biddingMix,
                                 String baseFileName)
		throws RemoteException
	{
		props.setValues(numClients, (int) rampUpMillis, (int) sessionMillis, (int) rampDownMillis, tcpwThinkTime, biddingMix);
	
		String statsFile = clientArgs[0] + "/" +
				"client_stats_" + baseFileName;
				 
		String traceFile = clientArgs[1] + "/" + 
				"client_trace_" + baseFileName;
				
		p = new ClientRunnerThread(new String[] { traceFile, statsFile, null });
     	p.start();	
	}
	
								 
	public boolean isDone()
			throws RemoteException
	{
		return !p.isAlive();
	}
}


class ClientRunnerThread extends Thread 
{
	String[] clientArgs;

	public ClientRunnerThread(String[] clientArgs) {
		this.clientArgs = clientArgs;
	}
	
    public void run() {
		ClientEmulator.main(clientArgs);
    }
}
