package edu.rice.rubis.client;


import java.io.*;


public class ResultExtractor
{
	private String dirName;
	private String outfileName;

	private boolean thinkTime = true;
	private boolean biddingMix = true;
	private boolean toCache = true;

	private int minNumClients = 20; // 400;

	private int stepNumClients = 20; // 100;

	private int sessionMillis = 300000; // 300000;

	private int maxRuns = 50;


	public static void main(String arg[])
		throws Exception
	{
		ResultExtractor extractor = new ResultExtractor(arg[0], arg[1]);

		extractor.execute();
		extractor.executeClientStats();
	}


	public ResultExtractor(String dirName, String outfileName)
	{
		this.dirName = dirName;

		this.outfileName = outfileName;

	}


	public void execute()
		throws IOException
	{
		File dir = new File(dirName);

		PrintWriter output = new PrintWriter(new FileWriter(new File(dir, outfileName)));
		PrintWriter output2 = new PrintWriter(new FileWriter(new File(dir, "servlets" + outfileName)));

		// Loop over client stats
		for (int i = 0; i < maxRuns; i++) {
			System.out.println(i);

			int numClients = minNumClients + i * stepNumClients;

			String statsFileName = getServerStatsFileName(numClients, sessionMillis,
														  toCache, biddingMix, thinkTime);

			System.out.println(statsFileName);
			File statsFile = new File(dir, statsFileName);

			try {
				LineNumberReader reader = new LineNumberReader(new FileReader(statsFile));

				String line;
				/*
				while ((line = reader.readLine()) != null) {
					// System.out.println(line);
					if (line.indexOf("<td>Totals</td>") != -1) {
						System.out.println("********");

						output.print("method totals, ");
						output.print(sessionMillis);
						output.print(", ");
						output.print(toCache);
						output.print(", ");
						output.print(numClients);

						for (int j = 0; j < 13; j++) {
							line = reader.readLine();

							int start = line.indexOf("<td>") + 4;
							int end = line.indexOf("</td>");

							String element = line.substring(start, end);
							output.print(", ");
							output.print(element);
						}

						output.println();
						break;
					}
				}
				*/

				while ((line = reader.readLine()) != null) {
					// System.out.println(line);
					if (line.indexOf("<td>Totals</td>") != -1) {
						System.out.println("********");

						output2.print("servlet totals, ");
						output2.print(sessionMillis);
						output2.print(", ");
						output2.print(toCache);
						output2.print(", ");
						output2.print(numClients);

						for (int j = 0; j < 2; j++) {
							line = reader.readLine();

							int start = line.indexOf("<td>") + 4;
							int end = line.indexOf("</td>");

							String element = line.substring(start, end);
							output2.print(", ");
							output2.print(element);
						}

						output2.println();
						break;
					}

				}
			} catch (FileNotFoundException e) {
				System.err.println(e);
				System.err.println("Skipping file " + statsFileName);
			}
		}

		output.close();
		output2.close();
		// Loop over server stats
	}


	int[] diff = {5, 2, 0, 0, 3, 0, 6 };

	public void executeClientStats()
		throws IOException
	{
		File dir = new File(dirName);

		PrintWriter output = new PrintWriter(new FileWriter(new File(dir, "client" + outfileName)));

		// Loop over client stats
			for (int j = 0; j < 3; j++) {
		for (int i = 0; i < maxRuns; i++) {

			int numClients = minNumClients + i * stepNumClients;


				String statsFileName = getClientStatsFileName(j, numClients, sessionMillis,
															  toCache, biddingMix, thinkTime);

				System.out.println(statsFileName);
				File statsFile = new File(dir, statsFileName);

				try {
					LineNumberReader reader = new LineNumberReader(new FileReader(statsFile));

					String line;

					boolean sessionTime = false;

					while ((line = reader.readLine()) != null) {
						// System.out.println(line);
						if (line.indexOf("<B>Total</B>") != -1) {
							if (!sessionTime) {
								sessionTime = true;
							}
							else {
								output.print("client totals, ");
								output.print(j);
								output.print(", ");
								output.print(sessionMillis);
								output.print(", ");
								output.print(toCache);
								output.print(", ");
								output.print(numClients);


								int end = 0;
								for (int k = 0; k < 7; k++) {
									if (k == 5) {
										line = reader.readLine();
										end = 0;
									}

									int start = line.indexOf("<B>", end) + 3;
									end = line.indexOf("</B>", start);

									if (k != 5) {
										String element = line.substring(start, end - diff[k]);

										output.print(", ");
										output.print(element);
									}
								}

								output.println();
								break;
							}
						}
					}
				} catch (FileNotFoundException e) {
					System.err.println(e);
					System.err.println("Skipping file " + statsFileName);
				}
			}
		}

		output.close();
		// Loop over server stats
	}


	public static String getServerStatsFileName(int numClients, int sessionMillis,
												boolean toCache, boolean biddingMix, boolean thinkTime)
	{
		return "server_stats_numc" + numClients + "_sess" + sessionMillis +
			   "_cache" + toCache +
			   "_bidmix" + biddingMix +
			   "_thinkTime" + thinkTime + ".html";
	}


	public static String getClientStatsFileName(int id, int numClients, int sessionMillis,
												boolean toCache, boolean biddingMix, boolean thinkTime)
	{
		return "client_stats_id" + id + "_numc" + numClients + "_sess" + sessionMillis +
			   "_cache" + toCache +
			   "_bidmix" + biddingMix +
			   "_thinkTime" + thinkTime + ".html";
	}
}